﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Mol;

namespace Examples
{
    public partial class FormExamples : Form
    {
        public FormExamples()
        {
            InitializeComponent();
        }

        private void FormExamples_Load(object sender, EventArgs e)
        {
            // ここで、またはこれ以前に、ライセンスを設定します（以下の行を置き換えてください）。
            _Mol.SetLicense("","","");
        }

        private void btnVector_Click(object sender, EventArgs e)
        {
            TestVector.Test();
        }

        private void btnMatrix_Click(object sender, EventArgs e)
        {
            TestMatrix.Test();
        }

        private void btnLe_Click(object sender, EventArgs e)
        {
            TestLe.Test();
        }

        private void btnLls_Click(object sender, EventArgs e)
        {
            TestLls.Test();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            TestSvd.Test();
        }

        private void btnEgv_Click(object sender, EventArgs e)
        {
            TestEgv.Test();
        }

        private void btnBigDecimal_Click(object sender, EventArgs e)
        {
            TestBigDecimal.Test();
        }

        private void btnSpline_Click(object sender, EventArgs e)
        {
            FormChart frm = new FormChart();
            frm.ShowDialog(this);
        }

        private void btnFourier_Click(object sender, EventArgs e)
        {
            int S = 100000;  // 計算データ数
            int E = 1000000; // 最大データ数
            int A = 100000;  // 加算データ数
            while (S <= E)
            {
                TestDFT dft = new TestDFT(S); // S は全データ数（１ページで一次元）
                double[] t = dft.ComputeForward(); // 内部で DftComplex を呼び出す（LasyDFT 呼び出しはコメント）
                T.P("Data number=" + S + " Time=(" + t[0] + "," + t[1] + ")");
                S += A;
            }
        }

        private void btnRand_Click(object sender, EventArgs e)
        {
            FormRand frm = new FormRand();
            frm.ShowDialog(this);
        }

        private void btnStat_Click(object sender, EventArgs e)
        {
            TestStat test = new TestStat();
            test.Test1();
            test.Test2();
        }

        private void btnCLT_Click(object sender, EventArgs e)
        {
            FormCLT frm = new FormCLT();
            frm.ShowDialog(this);
        }
    }
}
