﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Numerics;
using System.Text;
using System.Windows.Forms;

using Mol;

namespace Examples
{
    /// <summary>
    /// 線形連立方程式のテスト（例題）クラス
    /// </summary>
    public static class TestLe
    {
        /// <summary>
        /// 線形連立方程式の例題を実行します。
        /// </summary>
        public static void Test()
        {
            {
            //  MatrixDenseGeneralDouble A = new MatrixDenseGeneralDouble(4, 4);
            //  A.UserType = _Mol.USER_TYPE.USER_MATRIX_SYMMETRIC; // 一般行列上に対称行列を作成
            //  MatrixDenseSymmetricDouble A = new MatrixDenseSymmetricDouble(4);
                MatrixSparseSymmetricDouble A = new MatrixSparseSymmetricDouble(4);
                A[1, 1] = 1; A[1, 2] = -2; A[1, 3] = 3; A[1, 4] = 1;
                A[2, 2] = 1; A[2, 3] = -2; A[2, 4] = -1;
                A[3, 3] = 1; A[3, 4] = 5;
                A[4, 4] = 3;
                // 下半分も設定する。
                //for (int i = 1; i <= A.RowCount; ++i)
                //{
                //    for (int j = 1; j < i; ++j) A[i, j] = A[j, i];
                //}
                MatrixDenseGeneralDouble B = new MatrixDenseGeneralDouble(4, 2);
                B[1, 1] =  3; B[1, 2] = 1;
                B[2, 1] = -4; B[2, 2] = 1;
                B[3, 1] =  7; B[3, 2] = 1;
                B[4, 1] =  8; B[3, 2] = 1;
                LuSolver lu = LuSolver.Create(A);
                MatrixDenseGeneralDouble X = lu.Solve(B);
                T.P("係数行列 A=", A);
                T.P("B=", B);
                T.P("X=", X);
                T.P("(A*X-B)=", A * X - B);
            }
            {
                MatrixDenseSymmetricDouble A = new MatrixDenseSymmetricDouble(4);
                A[1, 1] = 1; A[1, 2] = -2; A[1, 3] = 3; A[1, 4] = 1;
                A[2, 2] = 1; A[2, 3] = -2; A[2, 4] = -1;
                A[3, 3] = 1; A[3, 4] = 5;
                A[4, 4] = 3;
                MatrixDenseGeneralDouble B = new MatrixDenseGeneralDouble(4, 2);
                B[1, 1] = 3; B[1, 2] = 1;
                B[2, 1] = -4; B[2, 2] = 1;
                B[3, 1] = 7; B[3, 2] = 1;
                B[4, 1] = 8; B[3, 2] = 1;
                LuSolver lu = LuSolver.Create(A);
                MatrixDenseGeneralDouble X = lu.Solve(B);
                T.P("MatrixDenseSymmetricDouble A=", A);
                T.P("B=", B);
                T.P("X=", X);
                T.P("(A*X-B)=", A * X - B);
            }
            {
                MatrixDenseSymmetricComplex A = new MatrixDenseSymmetricComplex(4);
                A[1, 1] = new Complex(1, 1); A[1, 2] = new Complex(-2, 2); A[1, 3] = new Complex(3, -3); A[1, 4] = new Complex(1, -1);
                A[2, 2] = new Complex(1, 1); A[2, 3] = new Complex(-2, 2); A[2, 4] = new Complex(-1, 1);
                A[3, 3] = new Complex(1, 1); A[3, 4] = new Complex(5, -5);
                A[4, 4] = new Complex(3, 3);
                VectorDenseComplex b = new VectorDenseComplex(4);
                b[1] = new Complex(3, 3);
                b[2] = new Complex(-4, -4);
                b[3] = new Complex(7, 7);
                b[4] = new Complex(8, 8);
                LuSolver lu = LuSolver.Create(A);
                VectorDenseComplex x = lu.Solve(b);
                T.P("MatrixDenseSymmetricComplex A=", A);
                T.P("b=", b);
                T.P("x=", x);
                T.P("(A*x-b)=", A * x - b);
            }
        }
    }
}
