﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Mol;

namespace Examples
{
    /// <summary>
    /// 線形最小二乗問題のテスト（例題）クラス
    /// </summary>
    public class TestLls
    {
        /// <summary>
        /// 線形最小二乗問題の例題を実行します。
        /// </summary>
        public static void Test()
        {
            {
                MatrixDenseGeneralDouble A = new Mol.MatrixDenseGeneralDouble(4, 3);
                MatrixDenseGeneralDouble B = new Mol.MatrixDenseGeneralDouble(4, 1);
                VectorDenseDouble b = new Mol.VectorDenseDouble(4);

                double a = 8;
                A[1, 1] = a; A[1, 2] = a; A[1, 3] = a;
                A[2, 1] = a; A[2, 2] = a; A[2, 3] = a;
                A[3, 2] = 1; A[4, 3] = 1;  // answer x = [1/a-2,1,1]

                b[1] = 1; b[2] = 1; b[3] = 1; b[4] = 1;
                T.P("Min|b-Ax|  A:", A);
                T.P("           b:", b);

                LlsSolver lls = LlsSolver.SolveKnownRank(A, b);

                T.P("b[1]=" + b[1] + " ==(1.0 / a - 2):" + ((1.0 / a - 2)) );
                T.P("b[2]=" + b[2] + " ==(1.0)");
                T.P("b[3]=" + b[3] + " ==(1.0)");
            }
            { // LSE
                VectorDenseDouble c = new VectorDenseDouble(3);
                VectorDenseDouble x = new VectorDenseDouble(4);
                VectorDenseDouble d = new VectorDenseDouble(3);
                for (int i = 1; i <= c.Size; ++i) c[i] = 1;
                for (int i = 1; i <= d.Size; ++i) d[i] = 1;
                MatrixDenseGeneralDouble A = new MatrixDenseGeneralDouble(3, 4);
                A[1, 1] = 7; A[1, 2] = 2;
                A[2, 1] = 2; A[2, 2] = 6; A[2, 3] = -2;
                A[3, 2] = -2; A[3, 3] = 5;
                MatrixDenseGeneralDouble B = new MatrixDenseGeneralDouble(3, 4);
                B[1, 1] = 2; B[1, 2] = 1;
                B[2, 1] = 1; B[2, 2] = 2; B[2, 3] = 1;
                B[3, 2] = 1; B[3, 3] = 2; B[3, 4] = 1;
                LlsSolver.SolveLSE(x, (MatrixDenseGeneralDouble)A.Clone(), (MatrixDenseGeneralDouble)B.Clone(), (VectorDenseDouble)c.Clone(), (VectorDenseDouble)d.Clone());
                T.P(" Min(|c-Ax|) subject to Bx=d: A", A);
                T.P("                            : B", B);
                T.P("                            : c", c);
                T.P("                            : d", d);
                T.P("(B * x - d).NormE() = " + (B * x - d).NormE());
                T.P("(A * x - c).NormE() = " + (A * x - c).NormE());
            }

        }
    }
}