﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Numerics;
using System.Text;
using System.Windows.Forms;

using Mol;

namespace Examples
{
    /// <summary>
    /// ベクトルのテスト（例題）クラス
    /// </summary>
    public class TestVector
    {
        /// <summary>
        /// ベクトルの例題を実行します。
        /// </summary>
        public static void Test()
        {
            VectorDenseDouble   vdd = new VectorDenseDouble(5);
            VectorDenseComplex  vdc = new VectorDenseComplex(5);
            VectorSparseDouble  vsd = new VectorSparseDouble(5);
            VectorSparseComplex vsc = new VectorSparseComplex(5);
            vdd[1] = 1; vdd[3] = 3; vdd[5] = 5;
            vsd[1] = 1; vsd[3] = 3; vsd[5] = 5;
            vdc[2] = new Complex(2, 2); vdc[4] = new Complex(4, 4);
            vsc[2] = new Complex(2, 2); vsc[4] = new Complex(4, 4);
            T.P("vdd:", vdd);
            T.P("vdd.Count=" + vdd.Count);
            T.P("vdd.Norm1=" + vdd.Norm1());
            T.P("vdd.Norm2=" + vdd.Norm2());
            T.P("vdd.NormI=" + vdd.NormI());
            T.P("vdc:", vdc);
            T.P("vsd:", vsd);
            T.P("vsc:", vsc);
            T.P("vsc.Conjugate():", vsc.Conjugate());
            T.P("vsc.Count=" + vsc.Count);
            T.P("vsc.Norm1=" + vsc.Norm1());
            T.P("vsc.Norm2=" + vsc.Norm2());
            T.P("vsc.NormI=" + vsc.NormI());
            T.P("vdd+vsd:", vdd + vsd);
            T.P("vsd-vdd:", vsd - vdd);
            T.P("vdc+vsc:", vdc + vsc);
            T.P("vsc-vdc:", vsc - vdc);
            T.P("vsd*vdd:" + (vsd * vdd));
            T.P("vsc*vdc:" + (vsc * vdc) + "=" +(vsc[2]*vdc[2]+vsc[4]*vdc[4]));
            T.P("vsc*vdc.Conjugate():" + (vsc * (VectorDenseComplex)vdc.Conjugate()));
            T.P("vsd*2.0:" , (vsd * 2.0));
            T.P("vdd/2.0:" , (vdd / 2.0));
        }
    }
}
